﻿# coding :utf-8
# winExplore v1.2
# Un globalPlugin NVDA pour faciliter la navigation par objets, et lister puis utiliser les éléments d'une fenêtre.
# 
import globalPluginHandler
import ui
from globalCommands import commands, SCRCAT_OBJECTNAVIGATION
import api
import textInfos
import speech
import controlTypes
from time import sleep
import wx
from winUser import * 
import winUser
import NVDAObjects
from keyboardHandler import KeyboardInputGesture
import config
import windowUtils
import ctypes
import globalVars
import appModuleHandler
import UIAHandler
from UIAHandler import handler
clientObject = handler.clientObject

cO=clientObject
CPC=clientObject.CreatePropertyCondition
hd16=None
versionWLM=0
avecEtiq=True 

if UIAHandler.isUIAAvailable:
	listeTypes=("Boutons","Boutons-radio",u"Cases à cocher",u"Zones d'édition","Listes",u"Éléments de liste",u"Listes déroulantes",u"Zones de listes modifiables","Liens",u"Onglets") 
else:
	ui.message(u"Version de Windows non supportée.")

def PutWindowOnForeground(hwnd, sleepNb, sleepTime):
	try:
		setForegroundWindow(hwnd)
	except:
		pass
	for i in [sleepTime]*(sleepNb-1):
		sleep(i)
		if winUser.getForegroundWindow() == hwnd:
			return True
	# last chance
	KeyboardInputGesture.fromName("alt+Tab").send()
	sleep(sleepTime)
	if winUser.getForegroundWindow() == hwnd:
		return true
	return False

class ListeObjets(wx.Dialog):
	_timer=None
	global versionWLM, hd16,avecEtiq 
	avecEtiq=True 
	versionWLM=0
	hd16=None
	
	def __init__(self, parent,ID, title, closeIfInactive): 
		super(ListeObjets, self).__init__(parent, ID,title) 
		self.closeIfInactive = closeIfInactive
		self.destroyed = False
		self.listElements=[obj[0] for obj in self.getlisteObjets(0,True)] 
		self.objectTypeHasChanged = True
		self.doGui()

	def doGui(self):
		panel = self
		panelSizer = wx.GridBagSizer (3,5)
		self.taggedObjectsCB = wx.CheckBox(panel, wx.ID_ANY, label =u"&Afficher seulement les éléments étiquetés")
		self.taggedObjectsCB.SetValue(True) 
		panelSizer.Add(self.taggedObjectsCB, pos=(0,0), span= (1,2), flag=wx.EXPAND|wx.ALL,border=10)
		self.typeLabel = wx.StaticText(panel, wx.ID_ANY, label="&Types : " )
		panelSizer.Add(self.typeLabel, pos=(1,0), span= (1,1), flag=wx.EXPAND|wx.LEFT,border=15)
		#the list boxes
		self.typeObjets = wx.ListBox(panel, wx.ID_ANY, style = wx.LB_SINGLE, size = (200, 400))
		self.typeObjets.SetItems(listeTypes)
		panelSizer.Add(self.typeObjets, pos=(2,0), span= (5,1), flag=wx.EXPAND|wx.LEFT|wx.BOTTOM,
			border=10) 
		self.typeObjets.Select(0) 
		self.elemLabel = wx.StaticText(panel, wx.ID_ANY, label=u"&Éléments : " )
		panelSizer.Add(self.elemLabel, pos=(1,1), span= (1,1), flag=wx.EXPAND|wx.LEFT,border=15)
		self.listeObjets = wx.ListBox(panel, wx.ID_ANY,  style = wx.LB_SINGLE, size = (300, 400))
		if len(self.getlisteObjets(0,avecEtiq))>0:   #choices=self.listElements,
			self.listeObjets.SetItems([obj[0] for obj in self.getlisteObjets(0,avecEtiq)])
			#self.listeObjets.Select(0) 
		panelSizer.Add(self.listeObjets, pos=(2,1), span=(5,1), flag=wx.EXPAND|wx.LEFT|wx.BOTTOM,
			border=10)
		# the buttons
		self.leftClickButton=wx.Button(panel, wx.NewId(), label =("Simple clic &gauche"), size = (120, 30))
		self.leftClickButton.SetDefault()
		self.rightClickButton=wx.Button(panel, wx.NewId(), label =("Simple clic &droit"), size = (120, 30))
		self.objetNavigateurButton=wx.Button(panel, wx.NewId(), label =(u"L'élément est \n l'&objet  navigateur"), size = (120, 50))
		self.cancelButton =wx.Button(panel,wx.ID_CANCEL, size = (120, 30))
		panelSizer.Add(self.leftClickButton,(2,2),flag=wx.ALL, border = 10)  
		panelSizer.Add(self.rightClickButton,(3,2),flag=wx.ALL, border = 10)
		#panelSizer.Add((-1,40))
		panelSizer.Add(self.objetNavigateurButton,(4,2),flag=wx.ALL, border = 10)  
		panelSizer.Add(self.cancelButton,(6,2),flag = wx.ALL, border= 10)
		panel.SetSizerAndFit(panelSizer)
		
		# the events
		self.taggedObjectsCB.Bind(wx.EVT_CHECKBOX,self.onCaseChange)
		self.typeObjets.Bind(wx.EVT_LISTBOX,self.onElementTypeChange) 
		self.typeObjets.Bind(wx.EVT_SET_FOCUS,self.onObjectTypeListBoxFocus) 
		self.listeObjets.Bind(wx.EVT_SET_FOCUS,self.onChildBoxFocus) 
		self.typeObjets.Bind(wx.EVT_KEY_DOWN, self.onKeydown)
		self.listeObjets.Bind(wx.EVT_KEY_DOWN, self.onKeydown)
		self.leftClickButton.Bind(wx.EVT_BUTTON, self.onLeftMouseButton) 
		self.leftClickButton.Bind(wx.EVT_KEY_DOWN, self.onKeydownButton)  	
		self.rightClickButton.Bind(wx.EVT_KEY_DOWN, self.onKeydownButton) 		
		self.rightClickButton.Bind(wx.EVT_BUTTON, self.onRightMouseButton)
		self.objetNavigateurButton.Bind(wx.EVT_BUTTON, self.pourNavigationObjet)
		self.cancelButton.Bind(wx.EVT_BUTTON,self.onCancelButton)
		self.cancelButton.Bind(wx.EVT_KEY_DOWN, self.onKeydownButton)
		self.Bind(wx.EVT_ACTIVATE, self.onActivate)
		self.Bind(wx.EVT_CLOSE, self.onClose)
		self.typeObjets.SetFocus()
		self.sayNumberOfElements()

	def onObjectTypeListBoxFocus(self, evt):
		self.sayNumberOfElements()
	
	def sayNumberOfElements(self):
		def callback (count):
			self._timer=None
			if not self.typeObjets.HasFocus(): return
			if count:
				msg = _(u"%s éléments") %str(count) if count > 1 else (u"Un élément")
				ui.message(msg)
			else:
				ui.message(u"aucun élément")
		if self._timer is not None:
			self._timer.Stop()
		self._timer = wx.CallLater(200,callback, self.listeObjets.Count) 
		
	def onChildBoxFocus(self, evt):
		self.listeObjets.Select(0) 	
		if self.listeObjets.GetCount() == 0:
			self.updateButtons(False) 
		else:
			if self.objectTypeHasChanged:
				self.listeObjets.Select(0) 
			self.updateButtons(True)		
		
	def getPositionXY (self):
		itemSelected=self.listeObjets.GetSelection() 
		n=self.typeObjets.GetSelection()
		locat=self.getlisteObjets(n,avecEtiq) [itemSelected][1]
		xyItem=(int(locat[0])+int(locat[2]/2),int(locat[1])+int(locat[3]/2))
		return xyItem  

	def onClose(self, evt):
		self.Destroy()
		self.destroyed = True  
		evt.Skip()
		
	def onCheckTaggedObjectsCheckBox(self, evt):
		self.onElementTypeChange(evt)	
	
	def getlisteObjets(self,n,avecEtiq):
		locat=None 
		name=""
		l=[] 
		global oDeb,versionWLM , hd16
		oCondition1=cO.CreateOrCondition(CPC(30003 ,50000),CPC(30003 ,50031))
		#oCondition0=cO.CreateOrCondition(oCondition1,CPC(30003 ,50016))
		oCondition0=CPC(30003 ,50000)
		conditions=((oCondition0),(CPC(30003 ,50013)),(CPC(30003 ,50002)),(CPC(30003 ,50004)),(CPC(30003 ,50008)),(CPC(30003 ,50007)),(CPC(30003 ,50015)),(CPC(30003 ,50003)),(CPC(30003 ,50005)),(CPC(30003 ,50019)))
		oCondition =conditions[n]
		if versionWLM==14:
			try:  
				objBW =oDeb.simpleFirstChild 
				for j in range(0,objBW.childCount-1):
					obj =objBW.getChild(j) 
					if obj.childCount==0 and (obj.role==9 or obj.role==36): 
						name = obj.name	
						locat=obj.location
						l.append((name,locat))
					for i in range(0,obj.childCount-1):
						if obj.getChild(i) and (obj.getChild(i).role==9 or obj.getChild(i).role==36):    
							locat =obj.getChild(i).location
							l.append((obj.getChild(i).name, locat))
				try:  
					hd1 = windowUtils.findDescendantWindow(oDeb.windowHandle,visible= True, className="Outlook Express Native Browser Class")	 #globalVars.foregroundObject
					hd2 = windowUtils.findDescendantWindow(hd1,visible= True, className="Outlook Express Message View") 
					hd = windowUtils.findDescendantWindow(hd2,visible= True, className="PreviewPane")
					elements = clientObject.ElementFromHandle(hd).FindAll(4,oCondition) 
					if elements.Length :
						for i in range (0, elements.Length):			
							if elements.GetElement(i).CurrentName.lower() in ("ligne vers le haut","ligne vers le bas",u"page précédente",u"page suivante",u"page vers la gauche",u"page vers la droite","colonne vers la gauche","colonne vers la droite"):
								continue
							if elements.GetElement(i).CurrentName:
								name=elements.GetElement(i).CurrentName
							elif elements.GetElement(i).GetCurrentPropertyValue(30045):
								name=elements.GetElement(i).GetCurrentPropertyValue(30045)
							elif name=="" and avecEtiq==False :name = "Sans nom" 
							if name != "" :#"Sans nom":
								#name = "Sans nom" if elements.GetElement(i).CurrentName=="" else elements.GetElement(i).CurrentName
								#continue
								locat =elements.GetElement(i).GetCurrentPropertyValue(30001)
						#for i in range (0, elements.Length):
							#if name=="Sans nom" : # and self.taggedObjectsCB.GetValue()==True:
								#continue
								l.append((name,locat))						
				except:
					pass
			except:
				print "except WLM14"
				pass
			return l	
	
		else: #cas general **********************
			try:
				hd =oDeb.windowHandle if versionWLM==0 else oDeb.simpleFirstChild.windowHandle  
				elements = clientObject.ElementFromHandle(hd).FindAll(4,oCondition)
				if elements.Length :
					for i in range (0, elements.Length): 
						#name=""
						if elements.GetElement(i).CurrentName.lower() in ("ligne vers le haut","ligne vers le bas",u"page précédente",u"page suivante",u"page vers la gauche",u"page vers la droite","colonne vers la gauche","colonne vers la droite"):
							continue
						if elements.GetElement(i).CurrentName!="":
							name=elements.GetElement(i).CurrentName
						elif elements.GetElement(i).GetCurrentPropertyValue(30045): #value
							name=elements.GetElement(i).GetCurrentPropertyValue(30045)
						elif elements.GetElement(i).GetCurrentPropertyValue(30094): #description
							name=elements.GetElement(i).GetCurrentPropertyValue(30094)
							print "elements.GetElement(i).GetCurrentPropertyValue(30094)"
						elif name=="" and  avecEtiq==False:
							name = "Sans nom" 
						if name!="":
							locat =elements.GetElement(i).GetCurrentPropertyValue(30001)
							l.append((name,locat))
			except:
				print u"pb cas général"
				pass		
		if versionWLM==16 :  # and hd16 and hd16!=None
			try:  		
				try:
					elements = clientObject.ElementFromHandle(hd16).FindAll(4,oCondition)
					if elements.Length :
						for i in range (0, elements.Length):			
							if elements.GetElement(i).CurrentName:
								name=elements.GetElement(i).CurrentName
								locat =elements.GetElement(i).GetCurrentPropertyValue(30001)
								l.append((name,locat))
							"""elif elements.GetElement(i).GetCurrentPropertyValue(30045):
								name=elements.GetElement(i).GetCurrentPropertyValue(30045)
							elif name=="" and  avecEtiq==False: name = "Sans nom" 
							if name!="":
								locat =elements.GetElement(i).GetCurrentPropertyValue(30001)
								l.append((name,locat))	"""
				except:
					print (u"elements du volet non trouvés")
					pass
			except LookupError:
				print (u"volet non trouvé")
				pass 		
		return l 
		
	def onCaseChange(self, evt): 
		global avecEtiq
		index=self.typeObjets.GetSelection()
		avecEtiq = self.taggedObjectsCB.GetValue()
		if index>=0:
			self.listeObjets.Clear()
			self.listeObjets.SetItems([obj[0] for obj in self.getlisteObjets(index,avecEtiq) ]) 
			self.sayNumberOfElements()
			self.objectTypeHasChanged = True

	def onElementTypeChange(self, evt): 
		global avecEtiq
		index=self.typeObjets.GetSelection()
		avecEtiq = self.taggedObjectsCB.GetValue()
		if index>=0:
			self.listeObjets.Clear()
			self.listeObjets.SetItems([obj[0] for obj in self.getlisteObjets(index,avecEtiq) ]) 		
			self.sayNumberOfElements()
			self.objectTypeHasChanged = True
			
	def updateButtons(self,enable = True):  
		if enable:
			self.leftClickButton.Enable()
			self.rightClickButton.Enable()
			self.objetNavigateurButton.Enable()
		else:
			self.leftClickButton.Disable()
			self.rightClickButton.Disable()
			self.objetNavigateurButton.Disable()
		
	def onKeydownButton(self, evt):
		keyCode= evt.GetKeyCode()
		if keyCode == wx.WXK_ESCAPE:
			self.Close()
			return
		evt.Skip()

	def onKeydown(self, event):
		keyCode= event.GetKeyCode()
		if keyCode == wx.WXK_ESCAPE:
			self.Close()
			return
		event.Skip()
		
	def onCancelButton(self, evt):
		self.Close()
		evt.Skip()
		
	def onActivate(self, evt):
		if not self.destroyed and self.closeIfInactive and not evt.GetActive():  
			self.Close()
		evt.Skip()

	def onLeftMouseButton(self,event):
		(x,y)=self.getPositionXY()
		self.Close()
		winUser.setCursorPos(x,y)
		mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,None,None)
		sleep(0.1)
		mouse_event(MOUSEEVENTF_LEFTUP,0,0,None,None)
	
	def onRightMouseButton(self,event):
		(x,y)=self.getPositionXY()
		self.Close()
		winUser.setCursorPos(x,y)
		mouse_event(MOUSEEVENTF_RIGHTDOWN,0,0,None,None)
		sleep(0.01)
		mouse_event(MOUSEEVENTF_RIGHTUP,0,0,None,None)		
			
	def pourNavigationObjet(self,event):
		(x0,y0)=self.getPositionXY()
		self.Close()
		oldSpeechMode = speech.speechMode
		speech.speechMode =speech. speechMode_off
		speech.cancelSpeech()
		sleep(0.2)
		api.processPendingEvents()
		def callback():
			obj=api.getDesktopObject().objectFromPoint(x0,y0)
			api.setNavigatorObject(obj)	
			api.moveMouseToNVDAObject(obj)
			speech.speakObject(obj)
		speech.speechMode = oldSpeechMode
		att=wx.CallLater(600,callback)
		
	def run(cls): 
		if not UIAHandler.isUIAAvailable:
			speech.speakMessage(_("Not available on windows Xp"))
		bdd = cls(None,wx.ID_ANY,(u"Liste des éléments dans la fenêtre"), True)
		bdd.CenterOnScreen()
		bdd.Show(True)
		PutWindowOnForeground(bdd.GetHandle(), 4, 0.1) 
	run = classmethod(run)

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	objArrowMode = 0

	def script_changeMode(self, gesture):
		if self.objArrowMode == 0:
			self.objArrowMode = 1
			ui.message(u"mode séquentiel")
		else:
			self.objArrowMode = 0
			ui.message("mode normal")

		if self.objArrowMode ==1: 
			self.bindGesture("kb:rightarrow", "rightArrow")
			self.bindGesture("kb:leftarrow", "leftArrow")
			self.bindGesture("kb:downarrow", "downArrow")
			self.bindGesture("kb:uparrow", "upArrow")
			self.bindGesture("kb:pageDown", "pageDown")
			self.bindGesture("kb:pageUp", "pageUp")
			self.bindGesture("kb:home", "firstObject")
			self.bindGesture("kb:enter", "activationObjetNavigateur")
			for e in ("kb:*","kb:$","kb:space") :
				self.bindGesture(e, "retourModeNormal")
		else:
			self.clearGestureBindings()
			self.bindGestures(self.__gestures)	
	# Translators: input help mode message for navObjets toggle command.
	script_changeMode.__doc__=_("Toggles navObjets mode between normal, and oneKey")
	script_changeMode.category = SCRCAT_OBJECTNAVIGATION
	
	def script_rightArrow(self, gesture):
		commands.script_navigatorObject_next(gesture)

	def script_leftArrow(self, gesture):
		commands.script_navigatorObject_previous(gesture)

	def script_downArrow(self, gesture):
		commands.script_navigatorObject_firstChild(gesture)
			
	def script_upArrow(self, gesture):
		commands.script_navigatorObject_parent(gesture)
			
	def script_firstObject(self, gesture):
		curObject=api.getForegroundObject() if api.getForegroundObject().role==1 else api.getForegroundObject().simpleParent
		api.setNavigatorObject(curObject)
		speech.speakObject(curObject,reason=controlTypes.REASON_FOCUS)
		
	def script_pageDown(self, gesture):
		info=api.getReviewPosition().copy()
		info.expand(textInfos.UNIT_LINE)
		info.collapse()
		res=info.move(textInfos.UNIT_LINE,1)
		if res!=0:
			api.setReviewPosition(info)
			info.expand(textInfos.UNIT_LINE)
			speech.speakTextInfo(info,unit=textInfos.UNIT_LINE,reason=controlTypes.REASON_CARET)
		else:
			commands.script_navigatorObject_nextInFlow(gesture)
		
	def script_pageUp(self, gesture):
		info=api.getReviewPosition().copy()
		info.expand(textInfos.UNIT_LINE)
		info.collapse()
		res=info.move(textInfos.UNIT_LINE,-1)
		if res!=0:
			api.setReviewPosition(info)
			info.expand(textInfos.UNIT_LINE)
			speech.speakTextInfo(info,unit=textInfos.UNIT_LINE,reason=controlTypes.REASON_CARET)
		else:
			# Do not move outside of the current window.
			commands.script_navigatorObject_previousInFlow(gesture)

	def script_activationObjetNavigateur(self, gesture): 
		if not config.conf["reviewCursor"]["simpleReviewMode"]:
			i=0
			oldSpeechMode = speech.speechMode
			speech.speechMode =speech. speechMode_off
			speech.cancelSpeech()
			sleep(0.2)
			api.processPendingEvents()
			commands.script_reviewMode_previous(gesture)
			sleep(0.3)
			if not config.conf["reviewCursor"]["simpleReviewMode"]:
				commands.script_reviewMode_previous(gesture)
				sleep(0.3)
			commands.script_review_activate(gesture)
			sleep(0.3)
			commands.script_reviewMode_next(gesture)
			sleep(0.3)
			if i==2:
				commands.script_reviewMode_next(gesture)
				sleep(0.3)
			speech.speechMode = oldSpeechMode	
		else:
			commands.script_review_activate(gesture)
			
	def script_retourModeNormal(self, gesture):
		if self.objArrowMode ==1:
			self.clearGestureBindings()
			self.bindGestures(self.__gestures)
			self.objArrowMode =0
			ui.message("mode normal")						
	
	def pourVersionWLM(self):  
		if appModuleHandler.getAppNameFromProcessID(api.getFocusObject().processID,True) =="wlmail.exe" :
			version = globalVars.foregroundObject.appModule.productVersion.split(".")[0]
			return int(version)
		else : return 0
		
	def fen16(self):
		try:
			hd2 = windowUtils.findDescendantWindow(globalVars.foregroundObject.windowHandle,visible= True, className="Outlook Express Native Browser Class")
			hd3 = windowUtils.findDescendantWindow(hd2,visible= True, className="WLXDUI")
			hd4 = windowUtils.findDescendantWindow(hd3,visible= True, className="OE Live View Host")
			hd5 = windowUtils.findDescendantWindow(hd4,visible= True, className="Outlook Express Message View")
			hd6= windowUtils.findDescendantWindow(hd5,visible= True, className="PreviewPane")
			hd16 = windowUtils.findDescendantWindow(hd6,visible= True, className="WLXDUI")
			return hd16	
		except:
			print (u"hd16 non trouvé")
			return None
		
	def script_listesElements(self,gesture):
		global versionWLM,  hd16,oDeb,  avecEtiq
		try:
			# pour WLM 2012 a l'ouverture
			obj = api.getFocusObject()
			if  obj.role==3 and not winUser.isWindowVisible(obj.windowHandle):
				ui.message(u"La fenêtre est inactive. Frappez une touche de déplacement.")
				return
		except:	
			return	
		try:
			oDeb=api.getForegroundObject()#.simpleFirstChild 
		except:
			ui.message(u"Un problème est rencontré.")
			return
		avecEtiq=True 
		try:	
			versionWLM =self.pourVersionWLM()	
		except:
			versionWLM =0
		try:
			if versionWLM ==16: hd16=self.fen16()	
		except:
			#print (u"hd16 non trouvé")	
			hd16=None
		ListeObjets.run()
	
	def script_test(self, gesture):
		pass	
	
	__gestures={
		"kb:control+nvda+$":"changeMode", 
		"kb(desktop):control+nvda+*":"changeMode", 
		"kb:control+nvda+pageUp":"pageUp",
		"kb:control+nvda+pageDown":"pageDown",
		"kb:control+shift+nvda+home":"firstObject", 
		"kb:control+shift+nvda+enter":"activationObjetNavigateur", 
		"kb:nvda+$":"listesElements",
		"kb(desktop):nvda+*":"listesElements", # Pb WLM 2012
		"kb:control+shift+y":"test",
	}
